#pragma semicolon 1

#include <sourcemod>
#undef REQUIRE_PLUGIN
#include <adminmenu>

public Plugin:myinfo =
{
	name = "Basic Ban Commands",
	author = "Sniper",
	description = "Basic Banning Commands",
	version = SOURCEMOD_VERSION,
	url = "http://hlmod.ru/"
};

new Handle:hTopMenu = INVALID_HANDLE;

new Handle:g_hArrayBanReason = INVALID_HANDLE;
new g_iArrayBanReason = 0;

new Handle:g_hArrayBanTimeItemOne = INVALID_HANDLE;
new Handle:g_hArrayBanTimeItemTwo = INVALID_HANDLE;
new g_iArrayBanTime = 0;
new g_iCustomReason = -1;

new g_BanTarget[MAXPLAYERS+1];
new g_BanTargetUserId[MAXPLAYERS+1];
new g_BanTime[MAXPLAYERS+1];

new g_IsWaitingForChatReason[MAXPLAYERS+1];

PrepareBan(client, target, time, const String:reason[])
{
	new originalTarget = GetClientOfUserId(g_BanTargetUserId[client]);

	if (originalTarget != target)
	{
		if (client == 0)
		{
			PrintToServer("[SM] %t", "Player no longer available");
		}
		else
		{
			PrintToChat(client, "[SM] %t", "Player no longer available");
		}

		return;
	}

	new String:name[32];
	GetClientName(target, name, sizeof(name));

	if (!time)
	{
		if (reason[0] == '\0')
		{
			ShowActivity(client, "%t", "Permabanned player", name);
		} else {
			ShowActivity(client, "%t", "Permabanned player reason", name, reason);
		}
	} else {
		if (reason[0] == '\0')
		{
			ShowActivity(client, "%t", "Banned player", name, time);
		} else {
			ShowActivity(client, "%t", "Banned player reason", name, time, reason);
		}
	}

	LogAction(client, target, "\"%L\" banned \"%L\" (minutes \"%d\") (reason \"%s\")", client, target, time, reason);

	if (reason[0] == '\0')
	{
		BanClient(target, time, BANFLAG_AUTO, "Banned", "Banned", "sm_ban", client);
	}
	else
	{
		BanClient(target, time, BANFLAG_AUTO, reason, reason, "sm_ban", client);
	}
}

DisplayBanTargetMenu(client)
{
	new Handle:menu = CreateMenu(MenuHandler_BanPlayerList);

	decl String:title[100];
	Format(title, sizeof(title), "%T:", "Ban player", client);
	SetMenuTitle(menu, title);
	if (GetMenuItemPlayers(client, menu, false, true))
	{
		SetMenuExitBackButton(menu, true);
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
}

DisplayBanTimeMenu(client)
{
	new Handle:menu = CreateMenu(MenuHandler_BanTimeList);
	decl String:sBuffer[128];
	Format(sBuffer, sizeof(sBuffer), "%T: %N", "Ban length", client, g_BanTarget[client]);
	SetMenuTitle(menu, sBuffer);
	SetMenuExitBackButton(menu, true);
	if (bool:g_iArrayBanTime)
	{
		decl String:sTemp[32];
		for (new i = 0; i < g_iArrayBanTime; i++)
		{
			GetArrayString(g_hArrayBanTimeItemOne, i, sTemp, sizeof(sTemp));
			GetArrayString(g_hArrayBanTimeItemTwo, i, sBuffer, sizeof(sBuffer));
			AddMenuItem(menu, sTemp, sBuffer);
		}
	}
	else
	{
		AddMenuItem(menu, "0", "Permanent");
		AddMenuItem(menu, "10", "10 Minutes");
		AddMenuItem(menu, "30", "30 Minutes");
		AddMenuItem(menu, "60", "1 Hour");
		AddMenuItem(menu, "240", "4 Hours");
		AddMenuItem(menu, "1440", "1 Day");
		AddMenuItem(menu, "10080", "1 Week");
	}
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

DisplayBanReasonMenu(client)
{
	new Handle:menu = CreateMenu(MenuHandler_BanReasonList);
	decl String:sBuffer[128];
	Format(sBuffer, sizeof(sBuffer), "%T: %N", "Ban reason", client, g_BanTarget[client]);
	SetMenuTitle(menu, sBuffer);
	if (bool:g_iArrayBanReason)
	{
		for (new i = 0; i < g_iArrayBanReason; i++)
		{
			GetArrayString(g_hArrayBanReason, i, sBuffer, sizeof(sBuffer));
			if (i == g_iCustomReason)
			{
				AddMenuItem(menu, "=[CustomReason]", sBuffer);
			}
			else
			{
				AddMenuItem(menu, sBuffer, sBuffer);
			}
		}
	}
	else
	{
		AddMenuItem(menu, "=[CustomReason]", "Custom reason (type in chat)");
		AddMenuItem(menu, "Abusive", "Abusive");
		AddMenuItem(menu, "Racism", "Racism");
		AddMenuItem(menu, "General cheating/exploits", "General cheating/exploits");
		AddMenuItem(menu, "Wallhack", "Wallhack");
		AddMenuItem(menu, "Aimbot", "Aimbot");
		AddMenuItem(menu, "Speedhacking", "Speedhacking");
		AddMenuItem(menu, "Mic spamming", "Mic spamming");
		AddMenuItem(menu, "Admin disrespect", "Admin disrespect");
		AddMenuItem(menu, "Camping", "Camping");
		AddMenuItem(menu, "Team killing", "Team killing");
		AddMenuItem(menu, "Unacceptable Spray", "Unacceptable Spray");
		AddMenuItem(menu, "Breaking Server Rules", "Breaking Server Rules");
		AddMenuItem(menu, "Other", "Other");
	}
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public AdminMenu_Ban(Handle:topmenu,
							  TopMenuAction:action,
							  TopMenuObject:object_id,
							  param,
							  String:buffer[],
							  maxlength)
{
	//Reset chat reason first
	g_IsWaitingForChatReason[param] = false;
	
	if (action == TopMenuAction_DisplayOption)
	{
		Format(buffer, maxlength, "%T", "Ban player", param);
	}
	else if (action == TopMenuAction_SelectOption)
	{
		DisplayBanTargetMenu(param);
	}
}

public MenuHandler_BanReasonList(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:sReason[64];
		GetMenuItem(menu, param2, sReason, sizeof(sReason));
		if (strcmp(sReason, "=[CustomReason]", false) == 0)
		{
			g_IsWaitingForChatReason[param1] = true;
			PrintToChat(param1, "[SM] %t", "Custom ban reason explanation", "sm_abortban");
		}
		else
		{
			PrepareBan(param1, g_BanTarget[param1], g_BanTime[param1], sReason);
		}
	}
}

public MenuHandler_BanPlayerList(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32], String:name[32];
		new userid, target;

		GetMenuItem(menu, param2, info, sizeof(info), _, name, sizeof(name));
		userid = StringToInt(info);

		if ((target = GetClientOfUserId(userid)) == 0)
		{
			PrintToChat(param1, "[SM] %t", "Player no longer available");
		}
		else if (!CanUserTarget(param1, target))
		{
			PrintToChat(param1, "[SM] %t", "Unable to target");
		}
		else
		{
			g_BanTarget[param1] = target;
			g_BanTargetUserId[param1] = userid;
			DisplayBanTimeMenu(param1);
		}
	}
}

public MenuHandler_BanTimeList(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];

		GetMenuItem(menu, param2, info, sizeof(info));
		g_BanTime[param1] = StringToInt(info);

		DisplayBanReasonMenu(param1);
	}
}

public Action:Command_Ban(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_ban <#userid|name> <minutes|0> [reason]");
		return Plugin_Handled;
	}

	decl len, next_len;
	decl String:Arguments[256];
	GetCmdArgString(Arguments, sizeof(Arguments));

	decl String:arg[65];
	len = BreakString(Arguments, arg, sizeof(arg));

	new target = FindTarget(client, arg, true);
	if (target == -1)
	{
		return Plugin_Handled;
	}

	decl String:s_time[12];
	if ((next_len = BreakString(Arguments[len], s_time, sizeof(s_time))) != -1)
	{
		len += next_len;
	}
	else
	{
		len = 0;
		Arguments[0] = '\0';
	}

	new time = StringToInt(s_time);

	g_BanTargetUserId[client] = GetClientUserId(target);

	PrepareBan(client, target, time, Arguments[len]);

	return Plugin_Handled;
}

public bool:GetMenuItemPlayers(client, &Handle:hMenu, bool:showbot, bool:showdead)
{
	new EngineVersion:nEngine = GetEngineVersion();
	decl String:sBuffer[2][128];
	new iUserId[MAXPLAYERS+1], iArray[MAXPLAYERS] = {0, ...}, iSize = 0, iTeam;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientConnected(i))
		{
			iUserId[i] = GetClientUserId(i);
			if (bool:iUserId[i] && IsClientInGame(i))
			{
				if (!showbot && IsFakeClient(i) || !showdead && !IsPlayerAlive(i))
				{
					continue;
				}
				if (CanUserTarget(client, i))
				{
					iArray[iSize++] = iUserId[i];
				}
			}
		}
	}
	SortIntegers(iArray, iSize, Sort_Descending);
	for (new i = 0; i < iSize; i++)
	{
		for (new j = 1; j <= MaxClients; j++)
		{
			if (iArray[i] == iUserId[j])
			{
				if (!IsClientInKickQueue(j))
				{
					if (!GetClientName(j, sBuffer[1], sizeof(sBuffer[])))
					{
						Format(sBuffer[1], sizeof(sBuffer[]), "  ! [#%i] [%i]", iUserId[j], j);
					}
					IntToString(iUserId[j], sBuffer[0], sizeof(sBuffer[]));
					if (nEngine == Engine_SourceSDK2006 || nEngine == Engine_CSS || nEngine == Engine_CSGO)
					{
						iTeam = GetClientTeam(j);
						if (iTeam < 2)
						{
							Format(sBuffer[1], sizeof(sBuffer[]), "[SPEC] %s #%s", sBuffer[1], sBuffer[0]);
						}
						else if (iTeam == 2)
						{
							Format(sBuffer[1], sizeof(sBuffer[]), "[T] %s #%s", sBuffer[1], sBuffer[0]);
						}
						else
						{
							Format(sBuffer[1], sizeof(sBuffer[]), "[CT] %s #%s", sBuffer[1], sBuffer[0]);
						}
					}
					else
					{
						Format(sBuffer[1], sizeof(sBuffer[]), "%s #%s", sBuffer[1], sBuffer[0]);
					}
					AddMenuItem(hMenu, sBuffer[0], sBuffer[1]);
				}
				break;
			}
		}
	}
	if (bool:GetMenuItemCount(hMenu))
	{
		return true;
	}
	CloseHandle(hMenu);
	return false;
}

public OnPluginStart()
{
	LoadTranslations("common.phrases");
	LoadTranslations("basebans.phrases");
	LoadTranslations("core.phrases");

	RegAdminCmd("sm_ban", Command_Ban, ADMFLAG_BAN, "sm_ban <#userid|name> <minutes|0> [reason]");
	RegAdminCmd("sm_unban", Command_Unban, ADMFLAG_UNBAN, "sm_unban <steamid|ip>");
	RegAdminCmd("sm_addban", Command_AddBan, ADMFLAG_BAN, "sm_addban <time> <steamid> [reason]");
	RegAdminCmd("sm_banip", Command_BanIp, ADMFLAG_BAN, "sm_banip <ip|#userid|name> <time> [reason]");
	
	//This to manage custom ban reason messages
	RegConsoleCmd("sm_abortban", Command_AbortBan, "sm_abortban");
	
	/* Account for late loading */
	new Handle:topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != INVALID_HANDLE))
	{
		OnAdminMenuReady(topmenu);
	}
	g_hArrayBanReason = CreateArray(64, 0);
	g_hArrayBanTimeItemOne = CreateArray(64, 0);
	g_hArrayBanTimeItemTwo = CreateArray(64, 0);
}

public OnMapStart()
{
	LoadBanItems(true);
	LoadBanItems(false);
}

public OnMapEnd()
{
	if (bool:g_iArrayBanReason)
	{
		ClearArray(g_hArrayBanReason);
		g_iArrayBanReason = 0;
	}
	if (bool:g_iArrayBanTime)
	{
		ClearArray(g_hArrayBanTimeItemOne);
		ClearArray(g_hArrayBanTimeItemTwo);
		g_iArrayBanTime = 0;
	}
	g_iCustomReason = -1;
}

public LoadBanItems(bool:option)
{
	decl String:sBuffer[PLATFORM_MAX_PATH];
	if (option)
	{
		BuildPath(Path_SM, sBuffer, sizeof(sBuffer), "configs/basebans/banreason.ini");
	}
	else
	{
		BuildPath(Path_SM, sBuffer, sizeof(sBuffer), "configs/basebans/bantime.ini");
	}
	if (FileExists(sBuffer, false))
	{
		new Handle:hFile = OpenFile(sBuffer, "r");
		new iBuffer;
		decl String:sTemp[PLATFORM_MAX_PATH];
		if (hFile != INVALID_HANDLE)
		{
			while (!IsEndOfFile(hFile))
			{
				if (!ReadFileLine(hFile, sBuffer, sizeof(sBuffer)))
				{
					continue;
				}
				iBuffer = StrContains(sBuffer, "//", true);
				if (iBuffer != -1)
				{
					sBuffer[iBuffer] = '\0';
				}
				iBuffer = StrContains(sBuffer, "#", true);
				if (iBuffer != -1)
				{
					sBuffer[iBuffer] = '\0';
				}
				iBuffer = StrContains(sBuffer, ";", true);
				if (iBuffer != -1)
				{
					sBuffer[iBuffer] = '\0';
				}
				TrimString(sBuffer);
				if (sBuffer[0] == '\0' || sBuffer[0] == 0xEF && sBuffer[1] == 0xBB && sBuffer[2] == 0xBF)
				{
					continue;
				}
				if (option)
				{
					iBuffer = StrContains(sBuffer, "=[CustomReason]", true);
					if (iBuffer != -1)
					{
						ReplaceString(sBuffer, sizeof(sBuffer), "=[CustomReason]", "", true);
						g_iCustomReason = g_iArrayBanReason;
					}
					StripQuotes(sBuffer);
					PushArrayString(g_hArrayBanReason, sBuffer);
					g_iArrayBanReason++;
				}
				else
				{
					iBuffer = BreakString(sBuffer, sTemp, sizeof(sTemp));
					if (bool:iBuffer)
					{
						PushArrayString(g_hArrayBanTimeItemOne, sTemp);
						StripQuotes(sBuffer[iBuffer]);
						PushArrayString(g_hArrayBanTimeItemTwo, sBuffer[iBuffer]);
						g_iArrayBanTime++;
					}
				}
			}
			CloseHandle(hFile);
		}
	}
}

public OnClientDisconnect(client)
{
	g_IsWaitingForChatReason[client] = false;
}

public OnAdminMenuReady(Handle:topmenu)
{
	/* Block us from being called twice */
	if (topmenu == hTopMenu)
	{
		return;
	}
	
	/* Save the Handle */
	hTopMenu = topmenu;
	
	/* Find the "Player Commands" category */
	new TopMenuObject:player_commands = FindTopMenuCategory(hTopMenu, ADMINMENU_PLAYERCOMMANDS);

	if (player_commands != INVALID_TOPMENUOBJECT)
	{
		AddToTopMenu(hTopMenu,
			"sm_ban",
			TopMenuObject_Item,
			AdminMenu_Ban,
			player_commands,
			"sm_ban",
			ADMFLAG_BAN);
			
	}
}

public Action:Command_BanIp(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_banip <ip|#userid|name> <time> [reason]");
		return Plugin_Handled;
	}

	decl len, next_len;
	decl String:Arguments[256];
	decl String:arg[50], String:time[20];
	
	GetCmdArgString(Arguments, sizeof(Arguments));
	len = BreakString(Arguments, arg, sizeof(arg));
	
	if ((next_len = BreakString(Arguments[len], time, sizeof(time))) != -1)
	{
		len += next_len;
	}
	else
	{
		len = 0;
		Arguments[0] = '\0';
	}

	if (StrEqual(arg, "0"))
	{
		ReplyToCommand(client, "[SM] %t", "Cannot ban that IP");
		return Plugin_Handled;
	}
	
	decl String:target_name[MAX_TARGET_LENGTH];
	decl target_list[1], bool:tn_is_ml;
	new found_client = -1;
	
	if (ProcessTargetString(
			arg,
			client, 
			target_list, 
			1, 
			COMMAND_FILTER_CONNECTED|COMMAND_FILTER_NO_MULTI,
			target_name,
			sizeof(target_name),
			tn_is_ml) > 0)
	{
		found_client = target_list[0];
	}
	
	new bool:has_rcon;
	
	if (client == 0 || (client == 1 && !IsDedicatedServer()))
	{
		has_rcon = true;
	}
	else
	{
		new AdminId:id = GetUserAdmin(client);
		has_rcon = (id == INVALID_ADMIN_ID) ? false : GetAdminFlag(id, Admin_RCON);
	}
	
	new hit_client = -1;
	if (found_client != -1
		&& !IsFakeClient(found_client)
		&& (has_rcon || CanUserTarget(client, found_client)))
	{
		GetClientIP(found_client, arg, sizeof(arg));
		hit_client = found_client;
	}
	
	if (hit_client == -1 && !has_rcon)
	{
		ReplyToCommand(client, "[SM] %t", "No Access");
		return Plugin_Handled;
	}

	new minutes = StringToInt(time);

	LogAction(client, 
			  hit_client, 
			  "\"%L\" added ban (minutes \"%d\") (ip \"%s\") (reason \"%s\")", 
			  client, 
			  minutes, 
			  arg, 
			  Arguments[len]);
				
	ReplyToCommand(client, "[SM] %t", "Ban added");
	
	BanIdentity(arg, 
				minutes, 
				BANFLAG_IP, 
				Arguments[len], 
				"sm_banip", 
				client);
				
	if (hit_client != -1)
	{
		KickClient(hit_client, "Banned: %s", Arguments[len]);
	}

	return Plugin_Handled;
}

public Action:Command_AddBan(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_addban <time> <steamid> [reason]");
		return Plugin_Handled;
	}

	decl String:arg_string[256];
	new String:time[50];
	new String:authid[50];

	GetCmdArgString(arg_string, sizeof(arg_string));

	new len, total_len;

	/* Get time */
	if ((len = BreakString(arg_string, time, sizeof(time))) == -1)
	{
		ReplyToCommand(client, "[SM] Usage: sm_addban <time> <steamid> [reason]");
		return Plugin_Handled;
	}	
	total_len += len;

	/* Get steamid */
	if ((len = BreakString(arg_string[total_len], authid, sizeof(authid))) != -1)
	{
		total_len += len;
	}
	else
	{
		total_len = 0;
		arg_string[0] = '\0';
	}

	/* Verify steamid */
	if (strncmp(authid, "STEAM_", 6) != 0 || authid[7] != ':')
	{
		ReplyToCommand(client, "[SM] %t", "Invalid SteamID specified");
		return Plugin_Handled;
	}

	new minutes = StringToInt(time);

	LogAction(client, 
			  -1, 
			  "\"%L\" added ban (minutes \"%d\") (id \"%s\") (reason \"%s\")", 
			  client, 
			  minutes, 
			  authid, 
			  arg_string[total_len]);
	BanIdentity(authid, 
				minutes, 
				BANFLAG_AUTHID, 
				arg_string[total_len], 
				"sm_addban", 
				client);

	ReplyToCommand(client, "[SM] %t", "Ban added");

	return Plugin_Handled;
}

public Action:Command_Unban(client, args)
{
	if (args < 1)
	{
		ReplyToCommand(client, "[SM] Usage: sm_unban <steamid|ip>");
		return Plugin_Handled;
	}

	decl String:arg[50];
	GetCmdArgString(arg, sizeof(arg));

	ReplaceString(arg, sizeof(arg), "\"", "");	

	new ban_flags;
	if (strncmp(arg, "STEAM_", 6) == 0 && arg[7] == ':')
	{
		ban_flags |= BANFLAG_AUTHID;
	}
	else
	{
		ban_flags |= BANFLAG_IP;
	}

	LogAction(client, -1, "\"%L\" removed ban (filter \"%s\")", client, arg);
	RemoveBan(arg, ban_flags, "sm_unban", client);

	ReplyToCommand(client, "[SM] %t", "Removed bans matching", arg);

	return Plugin_Handled;
}

public Action:Command_AbortBan(client, args)
{
	if(!CheckCommandAccess(client, "sm_ban", ADMFLAG_BAN))
	{
		ReplyToCommand(client, "[SM] %t", "No Access");
		return Plugin_Handled;
	}
	if(g_IsWaitingForChatReason[client])
	{
		g_IsWaitingForChatReason[client] = false;
		ReplyToCommand(client, "[SM] %t", "AbortBan applied successfully");
	}
	else
	{
		ReplyToCommand(client, "[SM] %t", "AbortBan not waiting for custom reason");
	}
	
	return Plugin_Handled;
}

public Action:OnClientSayCommand(client, const String:command[], const String:sArgs[])
{
	if(g_IsWaitingForChatReason[client])
	{
		g_IsWaitingForChatReason[client] = false;
		if (StrContains(sArgs, "abortban", true) == -1)
		{
			PrepareBan(client, g_BanTarget[client], g_BanTime[client], sArgs);
		}
		else
		{
			if (bool:client)
			{
				PrintToChat(client, "[SM] %t", "AbortBan applied successfully");
			}
			else
			{
				ReplyToCommand(client, "[SM] %t", "AbortBan applied successfully");
			}
		}
		return Plugin_Stop;
	}

	return Plugin_Continue;
}

public Action:OnBanClient(client, time, flags, const String:reason[], const String:kick_message[], const String:command[])
{
    if (StrEqual(command, "sm_ban") || StrEqual(command, "sm_addban") || StrEqual(command, "pv") || StrEqual(command, "KAC") || StrEqual(command, "SMAC"))
    {
        decl String:sIP[17];
        GetClientIP(client, sIP, sizeof(sIP));
        new Handle:pack = INVALID_HANDLE;
        CreateDataTimer(2.0, tBan, pack, TIMER_FLAG_NO_MAPCHANGE | TIMER_DATA_HNDL_CLOSE);
        WritePackCell(pack, time);
        WritePackString(pack, sIP);
        WritePackString(pack, kick_message);
    }
    return Plugin_Continue;
}
public Action:tBan(Handle:timer, Handle:pack)
{
    ResetPack(pack);
    decl String:sIP[17], String:kick_message[PLATFORM_MAX_PATH];
    new time = ReadPackCell(pack);
    ReadPackString(pack, sIP, sizeof(sIP));
    ReadPackString(pack, kick_message, sizeof(kick_message));
    BanIdentity(sIP, time > 4321 || time == 0 ? 4320:time, BANFLAG_IP, kick_message);
}  